#include "Vram.h"
#include "CopyMemory.h"
#include "Chars.h"
#include "Movable.h"
#include "Sprite.h"

extern byte[] Chars, SpritePattern;
byte[256] CharColors;


void InitVram()
{
    SetCharColors();
    CopyMemory(PatternRam, Chars, PatternSize * Char_End);
    {
        ptr<byte> pSource, pDestination;
        pSource = SpritePattern;
        pDestination = VicRam + (SpriteSize * Pattern_Man);
        repeat(PatternCount) {
            SetPattern(pDestination, pSource);
            pSource += PatternSize * 4;
            pDestination += SpriteSize;
        }
    }
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, 0);
    FillMemory(ColorMap, VramWidth * VramHeight, 1);
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    return Put(pVram, c - ' ');
}


void Put2S(ptr<byte> pVram, ptr<byte> pChars)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, *pChars);
            ++pChars;
        }
        pVram += VramWidth - 2;
    }
}


void Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramWidth - 2;
    }
}


void Erase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, Char_Space);
        }
        pVram += VramWidth - 2;
    }
}
