constexpr ptr<byte> VicRam = (ptr<byte>)0x8000;
constexpr ptr<byte> Vram = VicRam + 0x400;
constexpr ptr<byte> PatternRam = VicRam + 0x800;
constexpr ptr<byte> ColorMap = (ptr<byte>)0xd800;

constexpr byte VramWidth = 40;
constexpr byte VramHeight = 25;
constexpr byte VramRowSize = VramWidth;
constexpr byte CharHeight = 8;
constexpr byte PatternSize = CharHeight;
constexpr byte SpriteSize = 64;

// constexpr byte WindowWidth = 32;
// constexpr byte WindowHeight = VramHeight;


extern void SetCharColors();
extern void SetPattern(ptr<byte> pDestination, ptr<byte> pSource);
extern ptr<byte> VramAddress(byte x, byte y);
extern ptr<byte> Put(ptr<byte> pVram, byte c);
extern void UpdateBackgroundChars();
extern void BackgroundToVram();
extern ptr<byte> VVramAddress(byte x, byte y);

extern void InitVram();
extern void ClearScreen();
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);

extern void Put2S(ptr<byte> pVram, ptr<byte> pChars);
extern void Put2C(ptr<byte> pVram, byte c);
extern void Erase2(ptr<byte> pVram);
