include "Zeropage.inc"
include "Vram.inc"

ext CharColors_
ext charOffset_

; void SetCharColors()
cseg
ColorSource:
defb 64,1
defb 16,3
defb 4,14
defb 4,7
defb 4,3
defb 8,1
defb 8,10
defb 2,6
defb 0

SetCharColors_: public SetCharColors_
    pha
        ldx #0
        ldy #0
        do
            lda ColorSource,x
        while ne
            sta <ZB0
            inx
            lda ColorSource,x
            inx
            do
                sta CharColors_,y
                iny
                dec <ZB0
            while ne | wend
        wend
    pla
rts


; void SetPattern(ptr<byte> pDestination, ptr<byte> pSource)
dseg
SetPattern_@Param0: public SetPattern_@Param0
SetPattern_pDestination:
    defw 0
SetPattern_@Param1: public SetPattern_@Param1
SetPattern_pSource:
    defw 0
pDestination equ ZW0
pSource equ ZW1
count equ ZB2
cseg
SetPattern_: public SetPattern_
    pha
        lda SetPattern_pDestination | sta <pDestination
        lda SetPattern_pDestination+1 | sta <pDestination+1
        lda SetPattern_pSource | sta <pSource
        lda SetPattern_pSource+1 | sta <pSource+1

        lda #0
        sta <ZB0
        sta <ZB1
        lda #16
        sta <count
        do
            ldx #2
            do
                ldy <ZB0 | lda [<pSource],y | iny | sty <ZB0
                ldy <ZB1 | sta [<pDestination],y | iny | sty <ZB1
                dex
            while ne | wend
            lda #0
            sta [<pDestination],y | iny | sty <ZB1
            dec <count
        while ne | wend
        ldy <ZB1
        lda #0
        do
            sta [pDestination],y | iny
            cpy #64
        while ne | wend
    pla
rts



; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        clc|adc	VramAddress_.y_ ; *5

        sta <ZW0
        lda #0
        sta <ZW0+1
        ;	w = w << 3	[3]
        asl	<ZW0 | rol <ZW0+1 ; *10
        asl	<ZW0 | rol <ZW0+1 ; *20
        asl	<ZW0 | rol <ZW0+1 ; *40

        lda <ZW0 | clc|adc VramAddress_.x_ | sta <ZW0
        lda <ZW0+1 | adc #0 | sta <ZW0+1

        lda <ZW0 | clc|adc #low Vram | tay
        lda <ZW0+1 | adc #high Vram | tax
	pla
rts



; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        lda Put_pVram
        sta <ZW0
        lda Put_pVram+1
        sta <ZW0+1
        lda Put_c
        ldy #0
        sta (<ZW0),y
        tax
        lda <ZW0+1
        clc|adc #high(ColorMap-Vram)
        sta <ZW0+1
        lda CharColors_,x
        sta (<ZW0),y
        
        lda Put_pVram | clc|adc #1 | tay
        lda Put_pVram+1 | adc #0 | tax
    pla
rts
